Moved configuration variables into their own rip_dvd.conf.dist file.
[rip_dvd/.git] / rip_dvd
1 #!/bin/bash
2 #
3 # Author: Alan J. Pippin (apippin@pippins.net)
4 # Date: 05/17/2009
5 #
6   REV=1.0
7 #
8 # Description: This script wraps a number of linux utilities to
9 # create a recipe for ripping protected DVDs, circumventing 
10 # ARcoSS and CRC checksum error protection schemes used on many
11 # newer DVDs. Edit as appropriate for your needs. I use this to
12 # backup DVDs I own, and do not condone any other activity it
13 # may be used for.
14 #
15 # Known Issues/Limitations:
16 # - Mirror mode is always done in ISO mode
17 #
18 # Package Dependencies (apt-get install these for example):
19 # lsdvd dvdauthor gddrescue dvdbackup tovid mencoder mplayer genisoimage libdvdcss2
20 #
21 # Specific Executable (program) Dependencies (must be found in $PATH):
22 # volname makexml lsdvd dvdauthor gddrescue dvdbackup mencoder mplayer mkisofs
23 #
24 # Optional Dependencies:
25 # lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
26 #
27
28 ##############################################################################
29 # Local Machine Settings:
30 # Sources both the "default" conf file tracked by GIT (rip_dvd.conf.dist)
31 # and the local conf file created by each local machine (rip_dvd.conf)
32 # Copy the rip_dvd.conf.dist file to rip_dvd.conf and edit the later.
33 # This will allow you to override all the default values to meet your needs
34 # in a way that won't get clobbered when you pull updates from my GIT repo.
35 ##############################################################################
36 config="${0%/*}/rip_dvd.conf"
37 [ -e "${config}.dist" ] && . ${config}.dist
38 [ -e "${config}" ] && . ${config}
39
40 ###############################################
41 # Command line processing
42 typeset dvdname=""
43 typeset debug=""
44 typeset dest=""
45 typeset isofile=""
46 typeset vobfile=""
47 typeset dvdpath=""
48 typeset -i keep_intermediate_files=0
49 typeset -i make_final_dest_vob=0
50 typeset -i make_final_dest_iso=0
51 typeset -i make_final_dest_folder=0
52 typeset -i make_final_dest_avi=0
53 typeset -i errors=0
54 typeset -i show_usage=0
55 typeset -i mirror_mode=0
56 typeset -i target_bitrate=0
57 typeset -i target_size=0
58 typeset -i audio_2ch=0
59 typeset -i invalid_feature_title=0
60 typeset -i feature_title_override=0
61 typeset -i mplayer_dumpstream_incompatibility=0
62
63 while (($#)) && getopts 2mvifkxht:n:d:b:s:t: opt "$@"
64 do
65     case $opt in
66         (n)     dvdname=$OPTARG;;
67         (d)     dest=$OPTARG;;
68         (b)     target_bitrate=$OPTARG;;
69         (s)     target_size=$OPTARG;;
70         (2)     audio_2ch=1;;
71         (v)     make_final_dest_vob=1;;
72         (i)     make_final_dest_iso=1;;
73         (f)     make_final_dest_folder=1;; 
74         (x)     make_final_dest_avi=1;;
75         (m)     mirror_mode=1;;
76         (k)     keep_intermediate_files=1;;
77         (t)     feature_title_override=$OPTARG;;
78         (w)     set -$opt;;
79         (h)     show_usage=1;;
80         (:)     echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
81         (\?)    echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
82     esac
83 done
84
85 shift $((OPTIND-1))
86
87 function usage() {
88     echo >&2 "Usage: ${0##*/} -d <destdir> [ <options> ]"
89     echo >&2 "Revision $REV"
90     echo >&2 "Options:"
91     echo >&2 "   -d <destdir>  Specify the destination directory to store the ripped DVD to"
92     echo >&2 "   -n <dvdname>  Specify a path to a DVD folder or file to process:"
93     echo >&2 "                 1) If this option is not specified, the DVD will be ripped from $dev"
94     echo >&2 "                 2) If dvdname exists in $tmpdir, it will be ripped as a DVD instead of $dev"
95     echo >&2 "                 3) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
96     echo >&2 "                 4) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
97     echo >&2 "   -m            Make a mirror image of the DVD and save it as a DVD ISO file"
98     echo >&2 "                 The default operation is non-mirror mode where only the main"
99     echo >&2 "                 feature title will be ripped."
100     echo >&2 "   -v            Make the final image a DVD VOB file"
101     echo >&2 "   -i            Make the final image a DVD ISO file"
102     echo >&2 "   -f            Make the final image a DVD folder"
103     echo >&2 "   -x            Make the final image an AVI (XVID) file"
104     echo >&2 "                 You must also specify the target size or bitrate using the '-s' or '-b' options"
105     echo >&2 "   -s <size>     Set the target size of the AVI file in MB (ex: 700, 1000, etc)"
106     echo >&2 "   -b <bitrate>  Set the bitrate desired in the AVI file in kbits/sec (ex: 1500, 2000 (default), etc)"    
107     echo >&2 "   -2            Use 2 channel MP3 audio encoding when making an AVI file (default is 6 channel AC3)"
108     echo >&2 "   -k            Keep the intermediate files (good for debugging)"
109     echo >&2 "                 In -x mode, run with this option to keep the original .VOB file"
110     echo >&2 "                 By default, all intermediary files are deleted. Only the final image is kept"
111     echo >&2 "   -t <title>    Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
112     echo >&2 "   -w            Set the sh Execute/Verbose flag"
113     echo >&2 ""
114     exit 2
115 }
116
117 if (($errors)) || (($show_usage))
118 then
119   usage
120 fi
121
122 # Sanity Check - Command Line Options 
123 if [ "$dest" == "" ]; then
124   echo "-E- You must specify a destination directory with '-d'" | tee -a $logfile
125   usage
126 fi
127
128 if ([ $target_bitrate -ne 0 ] || [ $target_size -ne 0 ]) && [ $make_final_dest_avi -ne 1 ]; then
129   echo "-E- You can't specify a bitrate in non AVI file mode. You must specify '-x' when using '-b' or '-s'" | tee -a $logfile
130   usage
131 fi
132
133 if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_avi -eq 1 ]; then
134   echo "-E- You must specify a bitrate in AVI file mode. You must specify '-b' or '-s' when using '-x'" | tee -a $logfile
135   usage
136 fi
137
138 if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] && 
139    [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_avi -eq 0 ] && [ $mirror_mode -eq 0 ]; then
140   echo "-E- You must specify what type of final destination you want: '-m' or '-v' or '-i' or '-f' or '-x'" | tee -a $logfile
141   usage
142 fi
143
144 if [ $mirror_mode -eq 1 ]; then
145   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] || 
146      [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_avi -eq 1 ]; then
147     echo "-E- You can't specify '-v' or '-i' or '-f' or '-x' when operating in mirror mode with '-m'" | tee -a $logfile
148     usage
149   fi
150 fi
151
152 # Sanity Check - Key executables
153 [[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
154 [[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
155 [[ ! -x `which ddrescue` ]] && echo "-E- missing dependency: ddrescue" && exit
156 [[ ! -x `which dvdbackup` ]] && echo "-E- missing dependency: dvdbackup" && exit
157 [[ ! -x `which mencoder` ]] && echo "-E- missing dependency: mencoder" && exit
158 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
159 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
160 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
161
162 ###############################################
163
164 typeset -i ripdvd
165 if [ -z "$dvdname" ]; then
166   # make sure the DVD device is accessible
167   volname $dev > /dev/null 2>&1
168   if [ $? != 0 ]; then
169     echo "-E- Can't access the DVD device $dev"
170     exit 1
171   fi
172   # now capture the volume name from the device
173   dvdname=`volname $dev | awk '{ print $1 }'`
174   ripdvd=1
175 else 
176   # check to see if dvdname is a full path to a real directory
177   # if it is, set dvdname and dvdpath appropriately
178   if [ -d "$dvdname" ]; then
179     dvdpath="$dvdname"
180     dvdname=`basename "$dvdname"`
181     if [ -z "$dvdname" ]; then
182      echo "-E- Unable to extract dvdname from path: $dvdpath"
183      exit 1
184     fi
185     if [ ! -d "$dvdpath/VIDEO_TS" ]; then
186       echo "-E- You must supply a full path to a valid DVD folder with this option"
187       exit 1
188     fi
189   fi
190   # check to see if dvdname is a full path to an MPG2 (VOB) file
191   # if it is, set dvdname and vobfile appropriately
192   if [ -f "$dvdname" ]; then
193     vobfile="$dvdname"
194     dvdname=`basename "$dvdname"`
195     file "$vobfile" | grep -q "MPEG"
196     if [ $? == 0 ]; then
197       # It is a valid MPEG2 file, now strip the extension off our dvdname
198       dvdname=${dvdname%.[^.]*}
199     else 
200       echo "-E- Unsupported file type: $vobfile"
201       exit 1
202     fi
203   fi
204   ripdvd=0
205 fi
206
207 # remove bad characters from the dvdname
208 dvdname=${dvdname%.} # remove trailing '.' character
209
210 # make a "safe" dvdname (remove special characters)
211 safedvdname=`basename "$dvdname" | sed 's/[ !&*\\$?]/_/g'`
212
213 # Make sure we have a non-empty dvdname
214 if [ -z "$dvdname" ]; then
215   echo "-E- unable to determine dvdname"
216   exit 1
217 fi
218
219 # make sure our vobfile value is set
220 if [ -z "$vobfile" ]; then
221   vobfile="$dest/$dvdname.VOB"
222 fi
223
224 # set up some variables to hold various logfiles
225 logfile="$logdir/$dvdname.log"
226 passlogfile="$tmpdir/$safedvdname.log"
227 ddrescuelog=`tempfile`
228 dvdauthorlog=`tempfile`
229 encodelog=`tempfile`
230 dumplog=`tempfile`
231
232 # create the tmpdir if it doesn't already exist
233 if [ ! -d "$tmpdir" ]; then
234   mkdir -p "$tmpdir"
235   if [ $? != 0 ]; then
236     echo "-E- Unable to create the tmpdir: $tmpdir"
237     exit 1
238   fi
239 fi
240
241 # create the logdir if it doesn't already exist
242 if [ ! -d "$logdir" ]; then
243   mkdir -p "$logdir"
244   if [ $? != 0 ]; then
245     echo "-E- Unable to create the logdir: $logdir"
246     exit 1
247   fi
248 fi
249
250 ###############################################
251 # cleanup functions
252 cleanup() { 
253   if [ $keep_intermediate_files -eq 0 ]; then
254     [[ -e "$dvdauthorlog" ]] && rm -f "$dvdauthorlog"
255     [[ -e "$ddrescuelog" ]] && rm -f "$ddrescuelog"
256     [[ -e "$encodelog" ]] && rm -f "$encodelog"
257     [[ -e "$dumplog" ]] && rm -f "$dumplog"
258   else
259     [[ -e "$dvdauthorlog" ]] && echo "-> Keeping dvdauthor log: $dvdauthorlog" | tee -a "$logfile"
260     [[ -e "$ddrescuelog" ]] && echo "-> Keeping ddrescue log: $ddrescuelog" | tee -a "$logfile"
261     [[ -e "$encodelog" ]] && echo "-> Keeping encode log: $encodelog" | tee -a "$logfile"
262     [[ -e "$dumplog" ]] && echo "-> Keeping dump log: $dumplog" | tee -a "$logfile"
263   fi
264   echo ""
265 }
266
267 fatal_and_exit() {
268   if [[ -z "$1" ]]; then
269     msg="-E- control-c killed us"
270   else
271     msg=$1
272   fi
273   echo -e 2>&1 "$msg" | tee -a "$logfile"
274   if [[ -n "$mailto" ]]; then
275     echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
276   fi
277   exit 1
278 }
279
280 # Call our cleanup functions on INT and EXIT signals
281 trap fatal_and_exit INT
282 trap cleanup EXIT
283
284 ###############################################
285 # processing functions
286 function make_dvd_iso_image {
287
288   isofile="$1"
289
290   # check to see if we have a dvdpath to rip from instead of $dev
291   if [ -z "$dvdpath" ]; then
292     # load the CSS codes in the DVD drive 
293     lsdvd $dev >> "$logfile"
294     if [ $? != 0 ]; then
295       fatal_and_exit "-E- lsdvd $dev failed" 
296     fi
297
298     # read the DVD, ignoring/skipping CRC errors
299     ddrescue -n -b 2048 $dev "$isofile" "$ddrescuelog"
300     if [ $? != 0 ]; then
301       fatal_and_exit "-E- ddrescue -n -b 2048 $dev \"$isofile\" failed"
302     fi
303     cat "$ddrescuelog" >> "$logfile"
304   else
305     # rip from a path instead
306     make_dvd_iso_image_from_folder "$dvdpath" "$isofile" 1
307   fi
308 }
309
310 function make_dvd_iso_image_from_folder {
311   
312   src="$1"
313   dst="$2"
314   handle_error=$3
315   
316   echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
317
318   # make an iso image out of our directory
319   echo "   mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
320   mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
321
322   # set the audio languages from the iso if it exists and is non-zero in size
323   if [ -s "$dst" ]; then
324     get_feature_title "$dst"
325     get_audio_id_from_iso "$dst"
326   fi
327
328   # make sure we were able to create the iso image from the folder given to us
329   if [ ! -s "$dst" ] && [ $handle_error -eq 1 ]; then
330     echo "-> Unable to make an iso image from the DVD folder: $dvdpath"
331     echo "   Falling back to mplayer to create a main feature VOB from the folder instead: $dvdpath"
332     # remove the bad iso file
333     [[ -e "$dst" ]] && rm -f "$dst"
334     # get the feature title from the DVD folder
335     get_feature_title "$dvdpath"
336     # create our main VOB file from the ISO
337     create_main_vob_with_mplayer "$dvdpath" 
338     # get our audio id from the VOB file
339     get_audio_id_from_vob "$vobfile"
340   fi
341 }
342
343 function make_dvdbackup_folder_image {
344   # extract the feature title from the DVD image
345   echo "-> Extracting feature title using dvdbackup" | tee -a "$logfile"
346   [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
347   dvdbackup -F -i "$isofile" -o "$tmpdir" >> "$logfile"
348   if [ $? != 0 ]; then
349     fatal_and_exit '-E- dvdbackup -F -i "$isofile" -o "$tmpdir" failed'
350   fi
351 }
352
353 function make_dvdauthor_folder_image {
354   # create a new DVD video of the feature title
355   echo "-> Creating DVD video $dest/$dvdname" | tee -a "$logfile"
356   [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
357   dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
358   cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
359
360   # There is a chance that dvdauthor won't like some of the VOBs.
361   # We can't tell ahead of time which ones it will choke on. 
362   # So, we need to run it over and over again until it can process
363   # all the VOBs. If it can't handle one of them, run it through
364   # mencoder to fix it and try again. These errors are typically
365   # present due to the copy protection that ddrescue removed.
366   grep -q "SCR moves" $dvdauthorlog
367   while [ $? == 0 ]; do
368     # fix bad vobs that get the "SCR moves backwards" error:
369     #  STAT: Processing VTS_01_0.VOB...
370     #  ERR:  SCR moves backwards, remultiplex input.
371     badvob=`grep -v "^WARN:" $dvdauthorlog | grep -B 1 "SCR moves" | grep "Processing" | awk '{ print $3 }' | sed -e 's/\.\.\.//'`
372     if [[ ! -f "$badvob" ]]; then
373       fatal_and_exit "-E- Found a bad VOB, but could not extract it's name properly: $badvob"
374     fi
375     echo "-> Fixing SCR errors in DVD video file $badvob" | tee -a "$logfile"
376     cat $badvob | mencoder $lang_opts -quiet -of mpeg -mpegopts format=dvd -oac copy -ovc copy - -o $badvob.fixed >> "$logfile" 2>&1
377     mv -f $badvob.fixed $badvob
378     echo "-> Creating DVD video $dest/$dvdname"
379     dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
380     cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
381     grep -q "SCR moves" $dvdauthorlog
382   done
383 }
384
385 function get_feature_title {
386   source="$1"
387   # if a feature title was given on the command line, use it
388   if [ $feature_title_override -ne 0 ]; then
389     feature_title=$feature_title_override
390     return 0
391   fi
392   # otherwise, use lsdvd to figure it out
393   if [ $ripdvd -eq 1 ]; then
394     feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
395   else 
396     feature_title=`lsdvd "$source" 2>/dev/null | awk '/Longest/ { print $NF }'`
397   fi
398 }
399
400 function create_main_vob_with_cat {
401   # cd to the feature title DVD folder
402   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
403   if [ $? != 0 ]; then
404     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
405   fi
406
407   # concatenate all the VOBs together into 1 giant VOB
408   vobs=`/bin/ls -1 VTS*.VOB | grep -v "0.VOB" | tr '\n' ' '`
409   cat $vobs > "$tmpdir/$dvdname.VOB"
410
411   # cd back to the dir we started from
412   popd > /dev/null 2>&1
413 }
414
415 function create_main_vob_with_mplayer {
416
417   # argument processing  
418   source="$1"
419   remove_dumplog=$2
420
421   # make sure we have a valid feature title
422   if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
423     fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
424   fi
425
426   # check to make sure we didn't detect an mplayer dumpstream incompatibility earlier
427   if [ $mplayer_dumpstream_incompatibility -eq 1 ]; then
428     msg="-E- We detected an mplayer dumpstream incompatibility earlier."
429     msg="$msg We also detected another condition that requires us to use dumpstream. "
430     msg="$msg\n    Unable to rip this DVD in the mode you requested."
431     fatal_and_exit "$msg"
432   fi
433
434   # use mplayer to create the main VOB file
435   echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $vobfile" | tee -a "$logfile"
436   echo "   mplayer $lang_opts -dumpstream -dumpfile \"$vobfile\" -dvd-device \"$source\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
437   mplayer $lang_opts -dumpstream -dumpfile "$vobfile" -dvd-device "$source" dvd://$feature_title > $dumplog 2>&1
438   if [ $? != 0 ]; then
439     cat $dumplog | grep -v "^A:" >> "$logfile"
440     fatal_and_exit "-E- Mplayer Failed"
441   fi
442   cat $dumplog | grep -v "^A:" >> "$logfile"
443   [[ -e "$dumplog" ]] && [[ $remove_dumplog -eq 1 ]] && rm -f $dumplog
444 }
445
446 function get_audio_id_from_iso {
447   # Adjust our audio ID to find the english audio stream
448   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
449   iso="$1"
450   aidcheck=`tempfile`
451   aid=128
452   mplayer -v -endpos 0 -dvd-device "$iso" dvd://$feature_title > $aidcheck 2>&1
453   grep -q "aid: $aid" $aidcheck
454   while [ $? == 1 ] && [ $aid -lt 159 ]; do
455     (( aid = aid + 1 ))
456     grep -q "aid: $aid" $aidcheck
457   done
458   [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
459   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
460   # mencoder default DVD audio track language selection (english)
461   lang_opts="-aid $aid -alang en"
462 }
463
464 function get_crop_from_iso { 
465   FRAMES=10000
466   echo "-> Detecting black frame border crop value from ISO file"
467   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
468   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
469   [[ -e "md5sums" ]] && rm -f "md5sums"
470   CROP=`cat $dumplog | grep CROP | tail -1`
471   echo "   Found crop value of $CROP" >> "$logfile"
472   CROP=${CROP#* crop=}
473   CROP=${CROP%%\).*}
474   typeset -i CROPCHECK
475   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
476   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
477   if [ -z "$CROP" ]; then
478     fatal_and_exit "-E- Unable to extract CROP value from iso: $isofile"
479   fi
480   if [ $CROPCHECK -lt 0 ]; then 
481     CROP=""
482   else 
483     CROP=",crop=$CROP"
484   fi
485   echo "   Setting mencoder crop filter to: $CROP"
486 }
487
488 function get_audio_id_from_vob {
489   # Adjust our audio ID to find the english audio stream
490   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
491   vob="$1"
492   aidcheck=`tempfile`
493   aid=128
494   mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
495   grep -q "Found audio stream: $aid" $aidcheck
496   while [ $? == 1 ] && [ $aid -lt 159 ]; do
497     (( aid = aid + 1 ))
498     grep -q "Found audio stream: $aid" $aidcheck
499   done
500   [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
501   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
502   # mencoder default DVD audio track language selection (english)
503   lang_opts="-aid $aid -alang en"
504 }
505
506 function check_vob_for_corrupted_start {
507   # check to see if the beginning of the DVD has a form of copy protection
508   # where they have deliberately broken the first X number of frames of the DVD.
509   # If we don't skip these, our resulting VOB file will not play.
510   badvobcheck=`tempfile`
511   endpos=360
512   skip=0
513   mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
514   if [ $? != 0 ]; then
515     fatal_and_exit "-E- Mencoder Failed"
516   fi
517   grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
518   while [ $? == 0 ] && [ $skip -lt $endpos ]; do
519     (( skip = skip + 5 ))
520     echo "-> Bad VOB copy protection detected. Trying new skip value of $skip" | tee -a "$logfile"
521     mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
522     if [ $? != 0 ]; then
523       fatal_and_exit "-E- Mencoder Failed"
524     fi
525     grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
526   done
527   [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
528
529   # cat the giant VOB into mencoder to create a playable VOB file
530   cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$vobfile" >> "$logfile" 2>&1
531   if [ $? != 0 ]; then
532     fatal_and_exit "-E- Mencoder Failed"
533   fi
534 }
535
536 function check_vob_for_completeness {
537   # check to make sure we got out a complete VOB.
538   # there is another kind of copy protection where the VOB's may
539   # have "MPG EOF" frames in the middle of the stream. 
540   # this causes mencoder to not process the entire VOB, and exit without any errors.
541   # detect this by seeing how much smaller the dst vob is from the src vob.
542   MAX_FILESIZE_DELTA_PERCENT=70
543   SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
544   DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
545   FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
546   if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
547     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
548     echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
549     create_main_vob_with_mplayer "$isofile"
550     [[ -e "$dumplog" ]] && rm -f $dumplog
551     DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
552     FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
553     if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
554       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n    I recommend using another ripping mode like '-m' or '-i'"
555     fi
556   fi
557 }
558
559 function check_vob_for_too_many_video_packets {
560   # If our earlier algorithm to work around this failed, throw an error.
561   # check to see if this DVD has a protection scheme we don't know how to work around
562   # when I tried to burn the CARS DVD for example, you can't play the resulting VOB file.
563   # for some reason, the video is black, while the audio rolls, then the video finally comes
564   # in, but it is WAY off the audio. This appears to be due to some bad frames at the beginning of 
565   # the 1st VOB. Until I figure out how to work around this, detect it, and error out.
566   # instead of pulling the image from the disk again, you can pull it directly from the iso: -dvd-device $iso_path
567   grep -q "Too many video packets in the buffer:" "$logfile"
568   if [ $? == 0 ]; then
569     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
570     echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
571     create_main_vob_with_mplayer "$isofile"
572     grep -q "Too many video packets in the buffer:" $dumplog
573     if [ $? == 0 ]; then
574       [[ -e "$dumplog" ]] && rm -f $dumplog
575       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
576     fi
577     [[ -e "$dumplog" ]] && rm -f $dumplog
578   fi
579 }
580
581 function check_vob_for_a52_crc_errors {
582   # Let's see if we can playback our newly created VOB file without any errors.
583   # if there are issues, let's detect them now, and try to recreate the VOB
584   # there are some forms of copy protection that have missed above, that evidence
585   # themselves when we try to playback the VOB file. This was added to deal with
586   # the "a52: CRC check failed" copy protection scheme.
587   MAX_ERRORS=10
588   ENDPOS=120
589   echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
590   mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
591   cat $dumplog | grep -v "^A:" >> "$logfile"
592   errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
593   if [ $errors -gt $MAX_ERRORS ]; then
594     echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
595     create_main_vob_with_mplayer "$isofile"
596     echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
597     mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
598     if [ $? != 0 ]; then
599       cat $dumplog | grep -v "^A:" >> "$logfile"
600       fatal_and_exit "-E- Mplayer Failed"
601     fi
602     cat $dumplog | grep -v "^A:" >> "$logfile"
603     errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
604     if [ $errors -gt $MAX_ERRORS ]; then
605       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
606     fi
607   fi
608   [[ -e "$dumplog" ]] && rm -f $dumplog
609 }
610
611 function calculate_bitrate_from_target_size {
612   # determine what our bitrate needs to be if a target size was specified instead
613   if [ $target_size -ne 0 ]; then
614     vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
615     ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
616     echo "   With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
617   fi
618 }
619
620 function create_dvdauthor_dvd_xml_file {
621   # make a dvdauthor xml menu file to create a valid DVD video from 
622   # this script does a good job, but we'll still need to clean it up a bit after it runs
623   echo "-> Creating dvdauthor XML menu file" | tee -a "$logfile"
624   makexml -overwrite -dvd *.VOB -out dvd >> "$logfile" 2>&1
625   if [ $? != 0 ]; then
626     fatal_and_exit '-E- makexml -dvd *.VOB -out dvd failed'
627   fi
628
629   # replace the first line of the xml file to remove the bad dest path
630   awk -v line=1 -v new_content="<dvdauthor>" '{
631     if (NR == line) {
632       print new_content;
633     } else {
634       print $0;
635     }
636   }' dvd.xml > dvd.xml.new
637   mv -f dvd.xml.new dvd.xml
638   if [ $? != 0 ]; then
639     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
640   fi
641
642   # remove the "<video " property line from the xml file
643   cat dvd.xml | grep -v "<video" > dvd.xml.new
644   mv -f dvd.xml.new dvd.xml
645   if [ $? != 0 ]; then
646     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
647   fi
648   
649   # remove the extra <pgc>..</pgc> pairs
650   cat dvd.xml | awk 'BEGIN {x=1}
651   {
652     if ($0~"</pgc>") {x=0}
653     if (x==1) {print $0}
654     if ($0~"<pgc>") {x=1}
655   }' > dvd.xml.new
656   echo -e "</pgc>\n</titles>\n</titleset>\n</dvdauthor>" >> dvd.xml.new
657   mv -f dvd.xml.new dvd.xml
658   if [ $? != 0 ]; then
659     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
660   fi
661
662   # remove the VTS_*_0.VOB file as this is just the main menu video clip
663   cat dvd.xml | grep -v "VTS_.*_0.VOB" > dvd.xml.new
664   mv -f dvd.xml.new dvd.xml
665   if [ $? != 0 ]; then
666     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
667   fi
668 }
669
670 function check_for_mplayer_dumpstream_incompatibility {
671
672   echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
673
674   if [ ! -e "$vobfile" ]; then
675     # mplayer dumpstream does not work on DVDs that obscure the feature title.
676     # A DVD that has 99 titles, where the longest title isn't the main feature
677     # breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
678     # out what the feature title is. This script will run through that flow if we
679     # set use_mplayer_dumpstream to 0. Check for this here.
680     if [ $ripdvd -eq 1 ]; then
681       lsdvd $dev | grep -q "Title: 99"
682     else
683       lsdvd "$isofile" | grep -q "Title: 99"
684     fi
685     # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
686     if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
687       if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
688         echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a "$logfile"
689         echo "    You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
690         echo "    You can google this DVD to find out what it's feature title is, or you can play it in a conventional DVD player to find it." | tee -a "$logfile"
691         invalid_feature_title=1
692       else 
693         echo "    Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a "$logfile"
694         echo "-W- We still may not be able to autodetect the right feature title" | tee -a "$logfile"
695         echo "    You may need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
696         use_mplayer_dumpstream=0
697         invalid_feature_title=1
698       fi
699       return
700     fi
701   fi
702
703   # There is another form of protection that causes the mplayer dumpstream to fail. 
704   # This can be detected by telling mplayer to parse the VOB file by copying its audio
705   # video streams to a dummy output file (/dev/null). Do that here to check for that 
706   # problem before continuing.
707   if [ -e "$vobfile" ]; then
708     mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
709     mencoder $mplayer_opts "$vobfile" -o "/dev/null" > $dumplog 2>&1
710     grep -q "Too many audio packets in the buffer" $dumplog
711     if [ $? == 0 ]; then
712       echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
713       use_mplayer_dumpstream=0
714       mplayer_dumpstream_incompatibility=1
715     fi
716     [[ -e "$dumplog" ]] && rm -f $dumplog
717   fi
718 }
719
720 function fill_mythvideo_metadata {
721
722   # This function must be passed the filename as an argument
723   # The filename must be a full path to the file
724   filename="$1"
725
726   # Make sure the fill mythvideo metadata option has been set to 1
727   if [ $fill_mythvideo_metadata -eq 0 ]; then
728     echo "-> fill_mythvideo_metadata=0 therefore not updating mythvideo metadata for this rip" | tee -a "$logfile"
729     return 0
730   fi
731
732   # If the fill mythvideo metadata script is present, run it
733   # fill_mythvideo_metadata.plThis will download the metadata for the DVD we ripped.
734   if [[ -x `which fill_mythvideo_metadata.pl` ]]; then
735     echo "-> Running fill_mythvideo_metadata.pl to lookup/add/update the metadata for this DVD: $filename" | tee -a "$logfile"
736     fill_mythvideo_metadata.pl -N 0 -F "$filename" >> "$logfile" 2>&1
737   else
738     echo "-W- Unable to find the fill_mythvideo_metadata.pl script in your PATH. Unable to autofill the mythvideo DB for this rip." | tee -a "$logfile"
739     echo "    Set the fill_mythvideo_metadata variable to 0 in the script to avoid running this step." | tee -a "$logfile"
740   fi
741 }
742
743 function remove_intermediate_vob_file {
744   # remove the intermediate VOB file
745   if [ $keep_intermediate_files -eq 0 ]; then
746     [[ -e "$tmpdir/$dvdname.VOB" ]] && rm -f "$tmpdir/$dvdname.VOB"
747   else
748     echo "-> Keeping intermediate concatenated VOB file: $tmpdir/$dvdname.VOB" | tee -a "$logfile"
749   fi
750 }
751
752 function remove_intermediate_iso_file {
753   # remove the original DVD image 
754   if [ $keep_intermediate_files -eq 0 ]; then
755     [[ -e "$isofile" ]] && rm "$isofile"
756   else
757     echo "-> Keeping ddrescue intermediate iso file: $isofile" | tee -a "$logfile"
758   fi
759 }
760
761 function remove_intermediate_dvdbackup_folder {
762   if [ $keep_intermediate_files -eq 0 ]; then
763     [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
764   else
765     echo "-> Keeping intermediate dvdbackup folder: $tmpdir/$dvdname" | tee -a "$logfile"
766   fi
767 }
768
769 ###############################################
770 # MAIN
771
772 # Make a note of when this DVD rip started
773 date=`date`
774 echo -e "\n$date DVD rip started" >> "$logfile"
775
776 # Rip the DVD - Mirror Mode
777 if [ $mirror_mode -eq 1 ]; then
778   echo "-> Ripping DVD $dvdname to $dest"
779
780   # use ddrescue to make an ISO image of the disk
781   make_dvd_iso_image "$dest/$dvdname.iso"
782
783   # add this video data to the mythtv DB
784   fill_mythvideo_metadata "$dest/$dvdname.iso" 
785
786   # eject the disk upon completion
787   eject -T $dev
788
789   date=`date`
790   echo "$date DVD rip completed" | tee -a "$logfile"
791
792   if [[ -n "$mailto" ]]; then
793     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
794   fi
795
796 fi
797
798 # Rip the DVD - Main Title Feature Only
799 if [ $mirror_mode -eq 0 ]; then
800
801   # Rip image from DVD
802   if [ $ripdvd -eq 1 ]; then
803     echo "-> Ripping DVD $dvdname to $dest" | tee -a "$logfile"
804     # use ddrescue to make an ISO image of the disk
805     make_dvd_iso_image "$tmpdir/$dvdname.iso"
806   fi
807
808   # Rip image from DVD path
809   if [ -n "$dvdpath" ]; then
810     echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
811     make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
812   fi
813
814   # make sure our isofile value is set
815   if [ -z "$isofile" ]; then
816     isofile="$tmpdir/$dvdname.iso"
817   fi
818      
819   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_avi -eq 1 ]; then
820
821     if [ ! -e "$vobfile" ]; then
822       echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
823       
824       # get the feature title from the ISO
825       get_feature_title "$isofile"
826  
827       # get the crop value from the ISO
828       get_crop_from_iso
829
830       # check for mplayer dumpstream incompatibilities
831       # if they exist, this method will set this mode to 0.
832       check_for_mplayer_dumpstream_incompatibility
833
834       if [ $use_mplayer_dumpstream -eq 1 ]; then 
835
836         # get our audio id from the ISO file
837         get_audio_id_from_iso "$isofile"
838
839         # create our main VOB file from the ISO
840         create_main_vob_with_mplayer "$isofile"
841      
842         # remove the intermediate VOB file
843         remove_intermediate_vob_file
844
845         # it's possible that our VOB is still corrupted in some manner
846         # check to make sure it is still a good VOB before continuing.
847         check_for_mplayer_dumpstream_incompatibility
848
849       fi
850  
851       if [ $use_mplayer_dumpstream -eq 0 ]; then 
852
853         # use dvdbackup to make a DVD folder of the feature title
854         make_dvdbackup_folder_image
855   
856         # create our main VOB file
857         create_main_vob_with_cat
858
859         # get our audio id from the VOB file
860         get_audio_id_from_vob "$tmpdir/$dvdname.VOB"
861   
862         # check for corrupted VOB start
863         check_vob_for_corrupted_start
864  
865         # check to make sure our VOB is complete
866         check_vob_for_completeness
867
868         # check to make sure our VOB doesn't have too many video packets
869         check_vob_for_too_many_video_packets
870
871         # check to make sure our VOB doesn't have a52 crc errors
872         check_vob_for_a52_crc_errors
873
874         # remove the intermediate VOB file
875         remove_intermediate_vob_file
876
877       fi
878
879       # remove the intermediate ISO file
880       remove_intermediate_iso_file
881
882     else
883       echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
884     fi
885
886     # transcode the DVD
887     if [ $make_final_dest_avi -eq 1 ]; then
888       echo "-> Encoding the DVD video to an AVI file" | tee -a "$logfile"
889
890       # determine what our bitrate needs to be if a target size was specified instead
891       calculate_bitrate_from_target_size        
892       
893       # There was a lot of experimentation to arrive at these values
894       # These seem to work OK for me. If they don't work for you, feel
895       # free to adjust/change as needed.
896
897       # Edit these as needed to suite your needs
898       mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
899       mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
900       mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP"
901       mencoder_video_encoder_opts="-ovc xvid -xvidencopts pass=%PASS:chroma_opt:vhq=4:bvhq=1:quant_type=mpeg:bitrate=$target_bitrate:autoaspect:threads=$mencoder_threads"
902
903       # There are a number of different ways to encode 6 channel audio.
904       # I've loaded 3 different ways into the mencoder_audioch_opts.
905       # It will cycle through them until it finds one that works. 
906       # You can change the order to suit your needs.
907       if [ $audio_2ch -eq 0 ]; then
908
909         # These options produce good 6 channel audio for the internal mythvideo player, but they can't play in Windows.
910         #mencoder_audio_opts="-oac lavc -lavcopts acodec=ac3"
911         #mencoder_audioch_opts[0]="-channels 6 -af channels=6:6:0:5:1:4:2:3:3:2:4:1:5:0"
912
913         # These options produce good 6 channel audio for linux and windows (except the internal mythvideo player)
914         # This option requires playback under linux with mplayer to be done with options: -channels 6 -ac hwac3,hwdts,mad 
915         mencoder_audio_opts="-oac copy"
916
917         # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
918         mencoder_audioch_opts[0]="-channels 6 -af channels=6"
919         mencoder_audioch_opts[1]="-af channels=6"
920         mencoder_audioch_opts[2]=""
921
922      else 
923         # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
924         mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
925         mencoder_audioch_opts[0]=""
926      fi
927
928       # Do not edit this line. $mencoder_video_encoder_opts must be last
929       mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
930       mencoder_retval=0
931
932       for PASS in 1 2 
933       do 
934         # Set some options based on which pass we are in
935         mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
936         [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
937         [ $PASS -eq 1 ] && output_file="/dev/null"
938         [ $PASS -eq 2 ] && output_file="$dest/$dvdname.avi"
939   
940         # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
941         for CH_OPTS in "${mencoder_audioch_opts[@]}"; 
942         do
943           echo -e "   Encoding pass $PASS"
944           echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
945           mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
946           mencoder_retval=$? 
947           grep -q "\[channels\] Invalid" $encodelog
948           if [ $? != 0 ]; then      
949             break;
950           else
951             echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
952           fi
953         done
954         if [ $mencoder_retval != 0 ]; then
955           fatal_and_exit "-E- Unhandled mencoder error"
956         fi
957         # Concatenate the encode log to our main log file, greping out unwanted lines
958         cat $encodelog | grep -v "Pos:" >> "$logfile"
959       done
960
961       if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
962         [[ -e "$vobfile" ]] && rm -f "$vobfile";
963         [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
964       else
965         echo "-> Keeping VOB file: $vobfile" | tee -a "$logfile"
966         echo "-> Keeping mencoder 2pass logfile: $passlogfile"
967       fi
968     fi
969
970   # add this video data to the mythtv DB
971   [ $make_final_dest_avi -eq 1 ] && fill_mythvideo_metadata "$dest/$dvdname.avi" 
972   [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$vobfile" 
973     
974   else
975
976   # use dvdbackup to make a DVD folder of the feature title
977   make_dvdbackup_folder_image
978
979   # cd to the feature title DVD folder
980   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
981   if [ $? != 0 ]; then
982     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
983   fi
984   
985   # create the dvd.xml file for dvdauthor
986   create_dvdauthor_dvd_xml_file  
987
988   # make the final DVD folder image
989   make_dvdauthor_folder_image
990
991   # add this video data to the mythtv DB
992   fill_mythvideo_metadata "$dest/$dvdname/VIDEO_TS" 
993  
994   # cd back to the dir we started from
995   popd > /dev/null 2>&1
996
997   if [ $make_final_dest_iso -eq 1 ]; then
998
999     # make an iso image out of our directory
1000     make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso" 0
1001    
1002     # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory 
1003     if [ -s "$dest/$dvdname.iso" ]; then
1004       if [ $make_final_dest_folder -eq 0 ]; then
1005         echo "-> Removing DVD folder since ISO was created: $dest/$dvdname" | tee -a "$logfile"
1006         # remove the folder of the DVD image now that we have a .iso version of it
1007         [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
1008       fi
1009     else
1010       # we created an empty iso file, remove it
1011       echo "-> Removing empty ISO image: $dest/$dvdname.iso" | tee -a "$logfile"
1012       echo "-> Keeping the DVD folder since the ISO image couldn't be created properly: $dest/$dvdname"
1013       [[ -e "$dest/$dvdname.iso" ]] && rm "$dest/$dvdname.iso"
1014     fi
1015  
1016     # add this video data to the mythtv DB
1017     fill_mythvideo_metadata "$dest/$dvdname.iso" 
1018
1019   fi
1020
1021   fi
1022
1023   # remove the ddrescue DVD ISO image
1024   remove_intermediate_iso_file
1025
1026   # remove the tmp dvdbackup folder of the DVD image
1027   remove_intermediate_dvdbackup_folder
1028
1029   # eject the DVD disk upon completion
1030   [ $ripdvd -eq 1 ] && eject -T $dev
1031
1032   date=`date`
1033   echo "$date DVD rip completed" | tee -a "$logfile"
1034
1035   if [[ -n "$mailto" ]]; then
1036     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1037   fi
1038
1039 fi
1040